------------------------------------------------------------
revno: 9184
revision-id: squid3@treenet.co.nz-20100526044758-zz9k82yi19u4e2ei
parent: squid3@treenet.co.nz-20100526044322-puhib87k5ei79mhz
committer: Amos Jeffries <squid3@treenet.co.nz>
branch nick: SQUID_3_0
timestamp: Wed 2010-05-26 16:47:58 +1200
message:
  Author: Unknown
  Bug 2879: 3.0 regression in headers end finding
  
  Ported from Squid-2.
  
  Also, updates from Alex Rousskov for 3.x.
------------------------------------------------------------
# Bazaar merge directive format 2 (Bazaar 0.90)
# revision_id: squid3@treenet.co.nz-20100526044758-zz9k82yi19u4e2ei
# target_branch: http://www.squid-cache.org/bzr/squid3/branches\
#   /SQUID_3_0/
# testament_sha1: 0c03ad8cbaa76d25fa106820c43c6d782d536544
# timestamp: 2010-05-26 04:48:59 +0000
# source_branch: http://www.squid-cache.org/bzr/squid3/branches\
#   /SQUID_3_0
# base_revision_id: squid3@treenet.co.nz-20100526044322-\
#   puhib87k5ei79mhz
# 
# Begin patch
=== modified file 'src/http.cc'
--- src/http.cc	2010-03-06 06:13:30 +0000
+++ src/http.cc	2010-05-26 04:47:58 +0000
@@ -706,6 +706,9 @@
 
     assert(!flags.headers_parsed);
 
+    if (!readBuf->hasContent())
+        return;
+
     http_status error = HTTP_STATUS_NONE;
 
     HttpReply *newrep = new HttpReply;
@@ -1062,6 +1065,21 @@
     if (len == 0) { // reached EOF?
         eof = 1;
         flags.do_next_read = 0;
+
+        /* Bug 2879: Replies may terminate with \r\n then EOF instead of \r\n\r\n
+         * Ensure here that we have at minimum two \r\n when EOF is seen.
+         * TODO: Add eof parameter to headersEnd() and move this hack there.
+         */
+        if (readBuf->contentSize() && !flags.headers_parsed) {
+            /*
+             * Yes Henrik, there is a point to doing this.  When we
+             * called httpProcessReplyHeader() before, we didn't find
+             * the end of headers, but now we are definately at EOF, so
+             * we want to process the reply headers.
+             */
+            /* Fake an "end-of-headers" to work around such broken servers */
+            readBuf->append("\r\n", 2);
+        }
     }
 
     if (!flags.headers_parsed) { // have not parsed headers yet?

